--[[ include used code ]]
require "table_to_gui_transformations"
require "stgTools"

--[[ devToolsBox actions ]]
local function add_refresh_button(guiFrame, playerIndex)
	local myElement = guiFrame.add( { type= "button", name= "dfrRefreshPage", style= "tms_button", caption= "refresh" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	myElement.style.fontcolor = { r=0.5,g=0.5,b=1 }
end

local function add_bottom_frame(guiFrame, playerIndex, back_button)
	local myFlow = guiFrame.add( { type="flow", direction="horizontal" } )
	myFlow.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	myFlow.style.toppadding = 8
	if back_button then 
		local myElement = myFlow.add( { type= "button", name= "dfrBack", caption="back" } )
		myElement.style.fontcolor = { r=1,g=1,b=0 }
	end
	myFlow.add( { type= "button", name= "dfrClose", caption="close" } )
end

local function create_devToolsBox(player, playerIndex)
	return player.gui.center.add( { type="frame", name="devToolsBox", 
		caption = "devTools box", style="tms_frame_compact", direction="vertical"} )
end

local function open_or_renew_devToolsBox(player, playerIndex)
   local myFrame = player.gui.center.devToolsBox
 	if myFrame then
      myFrame.destroy();
   end
   return create_devToolsBox(player, playerIndex)
end

local function show_default_page(player, playerIndex)
	local myFrame = open_or_renew_devToolsBox(player, playerIndex)
	--local myElement = myFrame.add( { type= "label", caption= "-->Developer tools: " } )
	--myElement.style.font= "default-frame"
	--myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	
	--myElement = myFrame.add( { type= "label", style= "tms_label", caption= tf_VersionString(glob.cfg.version) } )
	--myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	local myFlow = myFrame.add( { type="flow", direction="vertical" --[[, style="tms_flow_compact"--]] } )
		--myFlow.style.toppadding = 2
		myFlow.style.bottompadding = 4

	--myElement = myFlow.add( { type= "label", style= "tms_label", caption="developer mode:" } )
	--myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myFlow = myFrame.add( { type="flow", direction="vertical", style="tms_flow_compact" } )

	myElement = myFlow.add( { type= "button", name= "dbnShowGlobTables", caption= "glob tables" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFlow.add( { type= "button", name= "dbnShowRemoteInterfaces", caption= "remote.interfaces" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myFlow = myFrame.add( { type="flow", direction="vertical", style="tms_flow_compact" } )
		myFlow.style.bottompadding = 4

	myElement = myFlow.add( { type= "button", name= "dbnShowGuiTables", caption= "gui tables" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myFlow = myFrame.add( { type="flow", direction="vertical", style="tms_flow_compact" } )
		myFlow.style.bottompadding = 4

	--myElement = myFlow.add( { type= "button", name= "dbnShowDefines", caption= "defines table" } )
	--myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFlow.add( { type= "button", name= "dbnShowGameProps", caption= "game properties" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFlow.add( { type= "button", name= "dbnShowXGameProps", caption= "old game properties" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	
	add_bottom_frame(myFrame, playerIndex, false)
	glob.devToolsFrame_page[playerIndex] = 1
end

local function show_devXGameProps_page(player, playerIndex)
	local myFrame = open_or_renew_devToolsBox(player, playerIndex)
	local myElement = myFrame.add( { type= "label", caption= "-->old game properties:" } )
	myElement.style.font= "default-frame"
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFrame.add( { type= "label", style= "tms_label", caption= string.format("game.speed = %g", game.speed ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFrame.add( { type= "label", style= "tms_label", caption= string.format("game.windspeed = %g", game.windspeed ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFrame.add( { type= "label", style= "tms_label", caption= string.format("game.windorientation = %g", game.windorientation ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFrame.add( { type= "label", style= "tms_label", caption= string.format("game.windorientationchange = %g", game.windorientationchange ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	local myFlow = myFrame.add( { type="flow", direction="vertical" } )
	myFlow.style.bottompadding = 10

	local myCompactFlow = myFlow.add( { type="flow", direction="vertical", style="tms_flow_compact" } )
	myElement = myCompactFlow.add( { type= "label", style= "tms_label", caption= string.format( "players = %d", #game.players ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	transform_keys_to_labels(game.forces, "game.forces", myFlow)

	myElement = myFrame.add( { type= "button", name= "dbnPrintStats",
			style= "tms_button", caption= "game.printentitystatistics() [sp only]" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFrame.add( { type= "button", name= "dbnPrintHelp",
			style= "tms_button", caption= "player.print(player.help)" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	--myElement.style.bottompadding = 10

	add_refresh_button(myFrame, playerIndex)
	add_bottom_frame(myFrame, playerIndex, true)
	glob.devToolsFrame_page[playerIndex] = 152
end 

local function show_devDefines_page(player, playerIndex)
	local myFrame = open_or_renew_devToolsBox(player, playerIndex)
	local myElement = myFrame.add( { type= "label", caption= "-->defines table:" } )
	myElement.style.font= "default-frame"
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	local myFlow = myFrame.add( { type="flow", direction="vertical" } )
	myFlow.style.bottompadding = 10

	transform_keysvaluepairs_to_labels(defines, "defines", myFlow)
	--transform_keysvaluepairs_to_labels(defines.difficulty, "defines.difficulty", myFlow)

	add_bottom_frame(myFrame, playerIndex, true)
	glob.devToolsFrame_page[playerIndex] = 102
end

local function show_devRemoteInterfaces_page(player, playerIndex)
	local myFrame = open_or_renew_devToolsBox(player, playerIndex)
	local myElement = myFrame.add( { type= "label", caption= "-->remote.interfaces:" } )
	myElement.style.font= "default-frame"
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	transform_keys_to_labels(remote.interfaces, "remote.interfaces", myFrame)
	transform_keys_to_labels(remote.interfaces.ThunderGui, "remote.interfaces.ThunderGui", myFrame)
	transform_keys_to_labels(remote.interfaces[MY_INTERFACE_NAME], "remote.interfaces."..MY_INTERFACE_NAME, myFrame)
	--[[--$$ list all keys of all interfaces 
	for key, value in pairs(remote.interfaces) do
		transform_keys_to_labels(remote.interfaces[key], "remote.interfaces." .. key, myFrame)
	end--]]

	add_refresh_button(myFrame, playerIndex)
	add_bottom_frame(myFrame, playerIndex, true)
	glob.devToolsFrame_page[playerIndex] = 105
end

local function show_devGameProps_page(player, playerIndex)
	local myFrame = open_or_renew_devToolsBox(player, playerIndex)
	local myElement = myFrame.add( { type= "label", caption= "-->game properties:" } )
	myElement.style.font= "default-frame"
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	
	myElement = myFrame.add( { type= "label", style= "tms_label",
			caption= string.format("game.peacefulmode = %s", tostring(game.peacefulmode) ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	
	myElement = myFrame.add( { type= "label", style= "tms_label",
			caption= string.format("game.difficulty = %d", game.difficulty) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFrame.add( { type= "label", style= "tms_label",
			caption= string.format("game.evolutionfactor = %g", game.evolutionfactor ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFrame.add( { type= "label", style= "tms_label",
			caption= string.format( "game.darkness: %g", game.darkness ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	--[[ old game wiki junk
	myElement = myFrame.add( { type= "label", style= "tms_label",
			caption= string.format("game.alwaysday = %s", tostring(game.alwaysday) ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	--]]

	myElement = myFrame.add( { type= "label", style= "tms_label",
			caption= string.format("game.finished = %s", tostring(game.finished) ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myFrame.add( { type= "label", style= "tms_label",
			caption= string.format("game.isdemo() = %s", tostring(game.isdemo()) ) } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	myElement.style.bottompadding = 10

	add_refresh_button(myFrame, playerIndex)
	add_bottom_frame(myFrame, playerIndex, true)
	glob.devToolsFrame_page[playerIndex] = 151
end

local function show_devGlobTables_page(player, playerIndex)
	local myFrame = open_or_renew_devToolsBox(player, playerIndex)
	local myElement = myFrame.add( { type= "label", caption= "-->glob tables:" } )
	myElement.style.font= "default-frame"
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	transform_keys_to_labels(glob, "glob", myFrame)
	transform_keysvaluepairs_to_labels(glob.cfg, "glob.cfg", myFrame)

	add_refresh_button(myFrame, playerIndex)
	add_bottom_frame(myFrame, playerIndex, true)
	glob.devToolsFrame_page[playerIndex] = 103
end

local function show_devGuiTables_page(player, playerIndex)
	local myFrame = open_or_renew_devToolsBox(player, playerIndex)
	local myElement = myFrame.add( { type= "label", caption= "-->gui tables:" } )
	myElement.style.font= "default-frame"
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	local gui = player.gui
	if gui.top.superTopGui and gui.top.superTopGui.childrennames then
		transform_values_to_labels(gui.top.superTopGui.childrennames, "superTopGui.childrennames", myFrame)
	end
	transform_values_to_labels(gui.top.childrennames, "gui.top.childrennames", myFrame)
	transform_values_to_labels(gui.left.childrennames, "gui.left.childrennames", myFrame)
	transform_values_to_labels(gui.center.childrennames, "gui.center.childrennames", myFrame)

	local myCompactFlow = myFrame.add( { type="flow", direction="vertical", style="tms_flow_compact" } )
		myCompactFlow.style.toppadding = 2
		myCompactFlow.style.bottompadding = 4

	myElement = myCompactFlow.add( { type= "button", name= "dbnDummyFrameTop", style= "tms_button", caption= "create/destroy top dummy" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myCompactFlow.add( { type= "button", name= "dbnDummyFrameLeft", style= "tms_button", caption= "create/destroy left dummy" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth

	myElement = myCompactFlow.add( { type= "button", name= "dbnDestroySuperGui", style= "tms_button", caption= "destroy superTopGui" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	myElement.style.fontcolor = { r=0.2,g=1,b=0.2 }

	myElement = myCompactFlow.add( { type= "button", name= "dbnDestroyGuiTop", style= "tms_button", caption= "destroy all named top gui elements" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	myElement.style.fontcolor = { r=1,g=0.0,b=0 }

	myElement = myCompactFlow.add( { type= "button", name= "dbnDestroyGuiLeft", style= "tms_button", caption= "destroy all named left gui elements" } )
	myElement.style.minimalwidth = glob.cfg.devToolsBox_minimalWidth
	myElement.style.fontcolor = { r=1,g=0.0,b=0 }

	add_refresh_button(myFrame, playerIndex)
	add_bottom_frame(myFrame, playerIndex, true)
	glob.devToolsFrame_page[playerIndex] = 104
end

local function devToolsBox_pageUpdate(player, playerIndex)
	devToolsBox_remove(player, playerIndex)

	if not glob.devToolsFrame_page then
		glob.devToolsFrame_page = {}
		glob.devToolsFrame_page[playerIndex] = 0
		return
	elseif not glob.devToolsFrame_page[playerIndex] or glob.devToolsFrame_page[playerIndex] <= 0 then 
		glob.devToolsFrame_page[playerIndex] = 0
		return
	elseif glob.devToolsFrame_page[playerIndex] == 1 then 
		show_default_page(player, playerIndex)

	elseif glob.devToolsFrame_page[playerIndex] == 102 then
		show_devDefines_page(player, playerIndex)
	elseif glob.devToolsFrame_page[playerIndex] == 103 then 
		show_devGlobTables_page(player, playerIndex)
	elseif glob.devToolsFrame_page[playerIndex] == 104 then
		show_devGuiTables_page(player, playerIndex)
	elseif glob.devToolsFrame_page[playerIndex] == 105 then 
		show_devRemoteInterfaces_page(player, playerIndex)
	elseif glob.devToolsFrame_page[playerIndex] == 151 then 
		show_devGameProps_page(player, playerIndex)
	elseif glob.devToolsFrame_page[playerIndex] == 152 then 
		show_devXGameProps_page(player, playerIndex)
	end
end

local function devToolsButton_changeCaption(player, caption)
	stg_setActionElementCaption(player, "dbnDevTools", caption)
end

local function devToolsBox_openClose(player, playerIndex)
	if not player.gui.center.devToolsBox then
		show_default_page(player, playerIndex)
		devToolsButton_changeCaption(player, "devTools -")
	else
		player.gui.center.devToolsBox.destroy()
		glob.devToolsFrame_page[playerIndex] = 0
		devToolsButton_changeCaption(player, "devTools +")
	end
end

function devToolsBox_remove(player, playerIndex)
	if player.gui.center.devToolsBox then
		player.gui.center.devToolsBox.destroy()
	end
end

function devToolsBox_close(player, playerIndex)
	devToolsBox_remove(player, playerIndex)
	if glob.devToolsFrame_page then
		glob.devToolsFrame_page[playerIndex] = 0
	end
	devToolsButton_changeCaption(player, "devTools +")
end

--[[ PUBLIC stuff ]]
function df_onCreate_devTools(playerIndex)
	local player = game.players[playerIndex]
	--$$ button
	stg_createActionButton(player, "dbnDevTools", "DevTools +") --[[this functions is equal to the following commented code
	local stGui = player.gui.top.superTopGui
	if stGui and stGui.stg_actionPanel and not stGui.stg_actionPanel.btnDevTools then
		stGui.stg_actionPanel.add( { type= "button", name= "dbnDevTools", style= "tms_buttonAlpha", caption= "DevTools +" } )
	end--]]
	--$$ frame
	devToolsBox_pageUpdate(player, playerIndex)
end

function df_onRemove_devTools(playerIndex)
	local player = game.players[playerIndex]
	stg_destroyActionElement(player, "dbnDevTools")
	devToolsBox_remove(player, playerIndex)
end

--[ event ongui_click ]
game.onevent(defines.events.onguiclick, 
function(event)
	local playerIndex = event.playerindex
	local player = game.players[playerIndex]

	--$$ regular used buttons
	if event.element.name == "dbnDevTools" then
		devToolsBox_openClose(player, playerIndex) --show_default_page()
	elseif event.element.name == "dfrClose" then
		devToolsBox_close(player, playerIndex)
	elseif event.element.name == "dfrBack" then 
		show_default_page(player, playerIndex)
	elseif event.element.name == "dfrRefreshPage" then
		devToolsBox_pageUpdate(player, playerIndex)


	--$$ pages
	elseif event.element.name == "dbnShowDefines" then
		show_devDefines_page(player, playerIndex)
	elseif event.element.name == "dbnShowGlobTables" then
		show_devGlobTables_page(player, playerIndex)
	elseif event.element.name == "dbnShowGuiTables" then
		show_devGuiTables_page(player, playerIndex)
	elseif event.element.name == "dbnShowRemoteInterfaces" then
		show_devRemoteInterfaces_page(player, playerIndex)
	elseif event.element.name == "dbnShowGameProps" then
		show_devGameProps_page(player, playerIndex)
	elseif event.element.name == "dbnShowXGameProps" then
		show_devXGameProps_page(player, playerIndex)


	--$$ toggle glob.cfg + [refresh gui +] refresh page
	elseif event.element.name == "dbnTglClockEnabled" then
		glob.cfg.clock = not glob.cfg.clock
		stg_updateSafe(player)
		devToolsBox_pageUpdate(player, playerIndex)
	elseif event.element.name == "dbnTglWeatherEnabled" then
		glob.cfg.wind = not glob.cfg.wind
		stg_updateSafe(player)
		devToolsBox_pageUpdate(player, playerIndex)
	elseif event.element.name == "dbnTglSpeedBtnEnabled" then
		glob.cfg.speedButton = not glob.cfg.speedButton
		stg_updateSafe(player)
		devToolsBox_pageUpdate(player, playerIndex)
	elseif event.element.name == "dbnTglPlayersBtnEnabled" then
		glob.cfg.playersButton = not glob.cfg.playersButton
		stg_updateSafe(player)
		devToolsBox_pageUpdate(player, playerIndex)
	elseif event.element.name == "dbnTglSafeMode" then
		glob.cfg.safeMultiplayerMode = not glob.cfg.safeMultiplayerMode
		if glob.cfg.safeMultiplayerMode then
			stg_updateAll()
		end
		devToolsBox_pageUpdate(player, playerIndex)
	elseif event.element.name == "dbnTglDevMode" then
		glob.cfg.developerMode = not glob.cfg.developerMode
		devToolsBox_pageUpdate(player, playerIndex)
	elseif event.element.name == "dbnTglRemoveOnSave" then
		glob.cfg.removeGui_onSave = not glob.cfg.removeGui_onSave
		devToolsBox_pageUpdate(player, playerIndex)
	elseif event.element.name == "dbnTglRemLeftOfSuper" then
		glob.cfg.removeElementsLeftOfSuperGui = not glob.cfg.removeElementsLeftOfSuperGui
		if glob.cfg.removeElementsLeftOfSuperGui then
			stg_updateSafe(player)
		end
		devToolsBox_pageUpdate(player, playerIndex)


	--$$ TUps and TDowns
	elseif event.element.name == "dbnTUpInterval" then
		if glob.cfg.update_interval < 3600 then -- one minute
			glob.cfg.update_interval = glob.cfg.update_interval + 10
			devToolsBox_pageUpdate(player, playerIndex)
		end
	elseif event.element.name == "dbnTDnInterval" then
		if glob.cfg.update_interval > 10 then
			glob.cfg.update_interval = glob.cfg.update_interval - 10
			devToolsBox_pageUpdate(player, playerIndex)
		end

	elseif event.element.name == "dbnTUpMinuteR" then
		if glob.cfg.clock_gt_minuteRounding_Value < 30 then
			glob.cfg.clock_gt_minuteRounding_Value = glob.cfg.clock_gt_minuteRounding_Value + 1
			devToolsBox_pageUpdate(player, playerIndex)
		end
	elseif event.element.name == "dbnTDnMinuteR" then
		if glob.cfg.clock_gt_minuteRounding_Value > 1 then
			glob.cfg.clock_gt_minuteRounding_Value = glob.cfg.clock_gt_minuteRounding_Value - 1
			devToolsBox_pageUpdate(player, playerIndex)
		end

	elseif event.element.name == "dbnTUpTBoxW" then
		if glob.cfg.devToolsBox_minimalWidth < 800 then -- one minute
			glob.cfg.devToolsBox_minimalWidth = glob.cfg.devToolsBox_minimalWidth + 20
			devToolsBox_pageUpdate(player, playerIndex)
		end
	elseif event.element.name == "dbnTDnTBoxW" then
		if glob.cfg.devToolsBox_minimalWidth > 200 then
			glob.cfg.devToolsBox_minimalWidth = glob.cfg.devToolsBox_minimalWidth - 20
			devToolsBox_pageUpdate(player, playerIndex)
		end


	--$$ disable devTools+ 
	elseif event.element.name == "dbnRemovedevToolsButton" then
		glob.cfg.devToolsButton = false
		--devToolsBox_close(player, playerIndex)
		show_guiOptions_page(player, playerIndex)
		stg_updateSafe(player)
		--tf_devToolsButton_remove(player, playerIndex)

	--$$ glob.cfg reset
	elseif event.element.name == "dbnResetCfg" then
		tf_reset_cfg(glob.cfg)
		stg_updateSafe(player)
		devToolsBox_pageUpdate(player, playerIndex)
	

	--$$ developerTools
	elseif event.element.name == "dbnDummyFrameLeft" then
		if player and player.gui.left.dummy then
			--$$destroy
			player.gui.left.dummy.destroy()
		else
			--$$create
			local myFrame = player.gui.left.add( { type="frame", name="dummy", caption="dummy sample" } )
			myFrame.add( { type="label", caption="Hello world!" } )
		end
		devToolsBox_pageUpdate(player, playerIndex)
	elseif event.element.name == "dbnDummyFrameTop" then
		if player and player.gui.top.dummy then
			--$$destroy
			player.gui.top.dummy.destroy()
		else
			--$$create
			local myFrame = player.gui.top.add( { type="frame", name="dummy", caption="dummy sample" } )
			myFrame.add( { type="label", caption="Hello world!" } )
		end
		devToolsBox_pageUpdate(player, playerIndex)

	elseif event.element.name == "dbnDestroyGuiTop" then
		--for _, player in pairs(game.players) do
			local myGui = player.gui.top
			for index, ElementName in pairs(myGui.childrennames) do
				local element = myGui[ElementName]
				if element then
					player.print( string.format( "devToolsMod: calling: gui.top.%s.destroy()", ElementName ) )
					element.destroy()
				end
			end
		--end
		devToolsBox_pageUpdate(player, playerIndex)

	elseif event.element.name == "dbnDestroyGuiLeft" then
		--for _, player in pairs(game.players) do
			local myGui = player.gui.left
			for key, ElementName in pairs(myGui.childrennames) do
				local element = myGui[ElementName]
				if element then
					player.print( string.format( "devToolsMod: calling: gui.top.%s.destroy()", ElementName ) )
					element.destroy()
				end
			end
		--end
		devToolsBox_pageUpdate(player, playerIndex)

	elseif event.element.name == "dbnDestroySuperGui" then
		--$$ destroy like a 'hacker' would, and not call stg_remove().
		--$$ the same as stg_update(player).
		if player.gui.top.superTopGui then
			player.gui.top.superTopGui.destroy()
		end
		devToolsBox_pageUpdate(player, playerIndex)

   elseif event.element.name == "dbnPrintStats" then
		--$$ this function is SP only in factorio; tested v0.11.15 and v0.11.16
		if #game.players <= 1 then
			game.printentitystatistics()
		end

   elseif event.element.name == "dbnPrintHelp" then
		player.print(player.help())
		--player.print(game.help())

	else
		--$$ did not recognize button
		return false
	end--$$ or prefect match
	return true
end)

